# $Id: ModGoogle.pm,v 1.9 2004/05/16 23:27:26 uhtu Exp $
# Copyright (c) 2002-2004 Phil Tom <phil@asdf.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModGoogle;

@ModGoogle::ISA = qw(OmniMod);

use strict;

use URI::Escape;

my $on = 1;
my $ua = LWP::UserAgent->new;
$ua->agent('Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:0.9.2) Gecko/20010726 Netscape6/6.1');
$ua->timeout(5); # 5s timeout


sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );

  $irc->privmsg( $channel, &do_google( split /\s+/, $message ) );
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );

  $irc->notice( $nick, &do_google( split /\s+/, $message ) );
}

sub applicable {
  my $message = shift;
  if ( $message =~ /^google\s+/ ) {
    return 1;
  }
  return 0;
}

# google search
sub do_google {
  my $url;
  my $keywords = '';
  my @words = @_;
 
  splice @words, 0, 1;
  foreach my $word (@words) {
    $keywords = $keywords . $word . '+';
  }
  chop $keywords;
  my $esckeys = uri_escape($keywords);
  pop @{$ua->requests_redirectable};
  pop @{$ua->requests_redirectable};
  my $urlstring = "http://www.google.com/search?q=${esckeys}&btnI=I%27m+Feeling+Lucky";
  my $request = HTTP::Request->new(GET => $urlstring);
  my $response = $ua->request($request);
  my $html = $response->as_string();
  my $locpos = index($html, 'Location:', 0);
  my $nlpos = index($html, "\n", $locpos);
  $url = substr($html, $locpos+10, $nlpos-$locpos-1);
  if ($url =~ /^200 OK/) {
    $url = "no results";
  }

  return $url;
}

1;
