# $Id: ModSelfChat.pm,v 1.8 2004/05/16 23:27:26 uhtu Exp $
# Copyright (c) 2003-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModSelfChat;

@ModSelfChat::ISA = qw(OmniMod);

use strict;

my $on = 1;
# hash of channel to last nick chatted
my %lastnick = ();
# hash of channel to last count of last nick chatted
my %lastcount = ();

my $WARNCOUNT = 10;
my $KILLCOUNT = 20;

sub name() {
  my $this = shift;
  return "Selfchat";
}

sub help {
  return if ! $on;

  if ( defined wantarray ) { # do we have help?
    return 0;
  }

}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;
  my $connection = shift;

  return if ! $on;

  # HACK
  return if ( $channel ne "#optimus" );

  my $newcount = &increment( $channel, $nick );
  if ( $newcount >= $KILLCOUNT ) {
    # don't do it every time
    if ( rand > 0.25 ) {
      $connection->kick( $channel, $nick, " self chat :) " );
    }
  }
  elsif ( $newcount >= $WARNCOUNT ) {
    # don't do it every time
    if ( rand > 0.25 ) {
      $irc->privmsg( $channel, "WARNING: $nick self chat detected" );
    }
  }

}

sub increment {
  my $channel = shift;
  my $nick = shift;

  $lastnick{ $channel } = $nick if ( ! defined $lastnick{ $channel } );
  $lastcount{ $channel } = 0 if ( ! defined $lastcount{ $channel } );

  if ( (lc $lastnick{ $channel }) eq (lc $nick) ) {
    $lastcount{ $channel }++;
  }
  else {
    $lastnick{ $channel } = $nick;
    $lastcount{ $channel } = 1;
  }

  return $lastcount{ $channel };
}

1;
